
// ------------------------------------------------------------------------
// -----                  FairMCEventHeader source file                -----
// -----                                                              -----
// -----    Created 08/12/05                      V. Friese           -----
// ------------------------------------------------------------------------


#include "FairMCEventHeader.h"



// -----   Default constructor   ------------------------------------------
FairMCEventHeader::FairMCEventHeader() 
: TNamed("MCEvent", "MC"), 
  fRunId(0),
  fEventId(0), 
  fX (0.), 
  fY (0.), 
  fZ (0.), 
  fT (0.), 
  fB (0.),
  ftheta1 (0.), 
  ftheta2 (0.),
  fphi1 (0.), 
  fphi2 (0.),
  fNPrim(0),
  fIsSet(kFALSE)

{
}
// ------------------------------------------------------------------------



// -----   Constructor with run identifier   ------------------------------
FairMCEventHeader::FairMCEventHeader(UInt_t runId) 
  : TNamed("MCEvent", "MC"), 
    fRunId(runId),
    fEventId(0), 
    fX (0.), 
    fY (0.), 
    fZ (0.), 
    fT (0.), 
    fB (0.),
    ftheta1 (0.), 
    ftheta2 (0.),
    fphi1 (0.), 
    fphi2 (0.),
    fNPrim(0),
    fIsSet(kFALSE)
  
{
}
// ------------------------------------------------------------------------



// -----   Standard constructor   -----------------------------------------
FairMCEventHeader::FairMCEventHeader(Int_t iEvent, Double_t x, Double_t y, 
				     Double_t z, Double_t t,Double_t b, Int_t nPrim, 
				     Double_t theta1,Double_t theta2,
				     Double_t phi1,Double_t phi2)
  : TNamed("MCEvent", "MC"), 
    fRunId(0),
    fEventId(iEvent), 
    fX (x), 
    fY (y), 
    fZ (z), 
    fT (t), 
    fB (b),
    ftheta1 (theta1), 
    ftheta2 (theta2),
    fphi1 (phi1), 
    fphi2 (phi2),
    fNPrim(nPrim),
    fIsSet(kFALSE)

{
}
// ------------------------------------------------------------------------



// -----   Destructor   ---------------------------------------------------
FairMCEventHeader::~FairMCEventHeader() { }
// ------------------------------------------------------------------------



// -----   Public method Reset   ------------------------------------------
void FairMCEventHeader::Reset() {
  fEventId = fNPrim = 0;
  fX = fY = fZ = fT = fB = 0.;
  ftheta1= ftheta2=0;
  fphi1= fphi2=0;
  fIsSet = kFALSE;
}
// ------------------------------------------------------------------------

  

ClassImp(FairMCEventHeader)
