// -------------------------------------------------------------------------
// -----                       FairEventManagerEditor                  -----
// -----                  Created 16/12/07  by M. Al-Turany            -----
// -------------------------------------------------------------------------
#ifndef ROOT_FAIREVENTMANAGEREDITOR
#define ROOT_FAIREVENTMANAGEREDITOR

#include "TGedFrame.h"
class FairEventManager;
class TGNumberEntry;
class TGCheckButton;
class TEveGValuator;
class FairEventManagerEditor : public TGedFrame
{
   FairEventManagerEditor(const FairEventManagerEditor&);            // Not implemented
   FairEventManagerEditor& operator=(const FairEventManagerEditor&); // Not implemented

protected:
   TObject *fObject;
   FairEventManager  *fManager;
   TGNumberEntry  *fCurrentEvent, *fCurrentPDG;
   TGCheckButton  *fVizPri;
   TEveGValuator *fMinEnergy ,*fMaxEnergy;  
public:
   FairEventManagerEditor(const TGWindow* p=0, Int_t width=170, Int_t height=30,
                      UInt_t options = kChildFrame, Pixel_t back=GetDefaultFrameBackground());
   virtual ~FairEventManagerEditor() {}
   virtual void SetModel( TObject* obj);
   void SelectEvent();
   void SelectPDG();                  
   void DoVizPri();
   void MaxEnergy();
   void MinEnergy();

   ClassDef(FairEventManagerEditor, 0); // Specialization of TGedEditor for proper update propagation to TEveManager.
};

#endif
